use glc::vector::Vector2f;
use serde::{Deserialize, Serialize};
use specs::{Component, VecStorage};

#[derive(Clone, Debug, Default, Serialize, Deserialize)]
pub struct Position {
    pos: Vector2f,
}

/* Position */

impl Position {
    pub fn get(&self) -> &Vector2f {
        &self.pos
    }
}

impl Position {
    pub(crate) fn new(pos: Vector2f) -> Self {
        Self { pos }
    }

    pub(crate) fn get_mut(&mut self) -> &mut Vector2f {
        &mut self.pos
    }
}

impl Component for Position {
    type Storage = VecStorage<Self>;
}
