use serde::{Deserialize, Serialize};
use specs::{Component, HashMapStorage};

#[derive(Clone, Debug, Serialize, Deserialize)]
pub enum Shape {
    Circle(f32),
}

/* Shape */

impl Component for Shape {
    type Storage = HashMapStorage<Self>;
}

impl Shape {
    pub fn radius(&self) -> f32 {
        match self {
            Self::Circle(r) => *r,
        }
    }
}
