use glc::matrix::Angle;

use crate::components::{ShipData, ShipsData};

/* Constants for ships in orbit */

pub const SHIP_ORBIT_ANGLE_DELTA_MIN: Angle<f32> = Angle::Deg(5000.0);
pub const SHIP_ORBIT_ANGLE_DELTA_RND: Angle<f32> = Angle::Deg(5000.0);
pub const SHIP_ORBIT_DISTANCE_MAX: f32 = 1.10; // %

pub const SHIP_DATA_IN_ORBIT: ShipData = ShipData {
    speed: 100.0,
    agility: Angle::Deg(60.0),
};

/* Constants for different ship types */

pub const SHIPS_DATA_FIGHTER: ShipsData = ShipsData {
    fighter: ShipData {
        speed: 120.0,
        agility: Angle::Deg(120.0),
    },
    bomber: ShipData {
        speed: 80.0,
        agility: Angle::Deg(80.0),
    },
    transporter: ShipData {
        speed: 100.0,
        agility: Angle::Deg(100.0),
    },
};

pub const SHIPS_DATA_TRADER: ShipsData = ShipsData {
    fighter: ShipData {
        speed: 100.0,
        agility: Angle::Deg(100.0),
    },
    bomber: ShipData {
        speed: 70.0,
        agility: Angle::Deg(70.0),
    },
    transporter: ShipData {
        speed: 120.0,
        agility: Angle::Deg(120.0),
    },
};

pub const SHIPS_DATA_RESEARCHER: ShipsData = ShipsData {
    fighter: ShipData {
        speed: 90.0,
        agility: Angle::Deg(90.0),
    },
    bomber: ShipData {
        speed: 60.0,
        agility: Angle::Deg(60.0),
    },
    transporter: ShipData {
        speed: 100.0,
        agility: Angle::Deg(100.0),
    },
};
